/* intelligent backup and copy tree */
'@echo off'

call RxFuncAdd 'SysFileTree', 'RexxUtil', 'SysFileTree'
version = '1.0'
numread = 0
numCopy = 0

say "VBCOPY" version
parse source source
parse arg from to
if to='' then do
    say "usage::vbcopy <from> <to>"
    say "from     path name"
    say "to       path name"
    exit 1
end

vdir = "vback"
address cmd
curpath = directory()
frompath = directory(from)
if lastpos('\',frompath)\=length(frompath) then frompath = frompath'\'
frompos = length(frompath)+38
call directory curpath
topath = directory(to)
if lastpos('\',topath)\=length(topath) then topath = topath'\'
topos = length(topath)+38
call directory curpath
if frompath='' then do
    say 'parameter from' from 'is bogus'
    exit 1
end /* do */
if topath='' then do
    say 'parameter to' to 'is bogus'
    exit 1
end /* do */

/* directories */

call SysFileTree frompath, 'fromdir', 'SD'


do i=1 to fromdir.0
    fromname = substr(fromdir.i,frompos)
    call SysFileTree topath||fromname, 'todir', 'D'
    if todir.0=0 then "md" to||fromname '1>nul: 2>nul:'
end /* do */

/* files */

call SysFileTree frompath'*', 'froms', 'SF'
n = froms.0  
if n=0 then do
    'nothing in from path:' from
    exit 1
end /* do */
numread = n

do i=1 to froms.0
    fromname = substr(froms.i,frompos)
    tocopy = 1
    call SysFileTree topath||fromname, 'tos', 'F'
    if tos.0>0 then do
        todate = left(tos.1,16)
        fromdate = left(froms.i,16)
        tocopy = (fromdate<>todate)
        call vback topath||fromname 'backing existing'
    end /* do */
    if tocopy then do
        address cmd "copy" frompath||fromname topath||fromname '1>nul: 2>nul:'
        call vback topath||fromname 'backing copy'
        numCopy = numCopy + 1
    end /* do */
end /* do */

say source 'read:' numread 'copied:' numCopy
exit 0


